diff --git a/include/odp/api/spec/atomic.h b/include/odp/api/spec/atomic.h
index 7638b93..36c50cb 100644
--- a/include/odp/api/spec/atomic.h
+++ b/include/odp/api/spec/atomic.h
@@ -116,7 +116,7 @@ void odp_atomic_add_u32(odp_atomic_u32_t *atom, uint32_t val);
  * Fetch and subtract from atomic uint32 variable
  *
  * @param atom    Pointer to atomic variable
- * @param val     Value to be subracted from the variable
+ * @param val     Value to be subtracted from the variable
  *
  * @return Value of the variable before the subtraction
  */
@@ -609,7 +609,7 @@ typedef union odp_atomic_op_t {
  * variables instead of uint64 to optimize performance on platforms that
  * implement a performance critical operation using locks.
  *
- * Init operations (e.g. odp_atomic_init_64()) are not atomic. This function
+ * Init operations (e.g. odp_atomic_init_u64()) are not atomic. This function
  * clears the op.init bit but will never set it to one.
  *
  * @param atomic_op  Pointer to atomic operation structure for storing
diff --git a/include/odp/api/spec/barrier.h b/include/odp/api/spec/barrier.h
index 01e3dc7..fbd1072 100644
--- a/include/odp/api/spec/barrier.h
+++ b/include/odp/api/spec/barrier.h
@@ -21,7 +21,7 @@ extern "C" {
 
 /**
  * @defgroup odp_barrier ODP BARRIER
- * Thread excution and memory ordering barriers.
+ * Thread execution and memory ordering barriers.
  *
  * @details
  * <b> Thread execution barrier (odp_barrier_t) </b>
diff --git a/include/odp/api/spec/buffer.h b/include/odp/api/spec/buffer.h
index ddadc69..5c632b5 100644
--- a/include/odp/api/spec/buffer.h
+++ b/include/odp/api/spec/buffer.h
@@ -96,7 +96,9 @@ odp_pool_t odp_buffer_pool(odp_buffer_t buf);
 /**
  * Buffer alloc
  *
- * The validity of a buffer can be cheked at any time with odp_buffer_is_valid()
+ * The validity of a buffer can be checked at any time with
+ * odp_buffer_is_valid().
+ *
  * @param pool      Pool handle
  *
  * @return Handle of allocated buffer
diff --git a/include/odp/api/spec/classification.h b/include/odp/api/spec/classification.h
index 1603d16..4891d26 100644
--- a/include/odp/api/spec/classification.h
+++ b/include/odp/api/spec/classification.h
@@ -109,7 +109,7 @@ typedef union odp_cls_pmr_terms_t {
 
 /**
  * Classification capabilities
- * This capability structure defines system level classfication capability
+ * This capability structure defines system level classification capability
  */
 typedef struct odp_cls_capability_t {
 	/** PMR terms supported by the classifier
@@ -389,7 +389,7 @@ typedef struct odp_pmr_param_t {
 } odp_pmr_param_t;
 
 /**
- * Intiailize packet matching rule parameters
+ * Initialize packet matching rule parameters
  *
  * Initialize an odp_pmr_param_t to its default values for all fields
  *
@@ -461,7 +461,7 @@ int odp_cls_cos_pool_set(odp_cos_t cos_id, odp_pool_t pool_id);
 *
 * @retval	pool handle of the associated pool
 * @retval	ODP_POOL_INVALID if no associated pool found or
-*		incase of an error
+*		in case of an error
 */
 odp_pool_t odp_cls_cos_pool(odp_cos_t cos_id);
 
diff --git a/include/odp/api/spec/config.h b/include/odp/api/spec/config.h
index 7a2d18b..4af3036 100644
--- a/include/odp/api/spec/config.h
+++ b/include/odp/api/spec/config.h
@@ -59,7 +59,7 @@ int odp_config_sched_prios(void);
 
 /**
  * Number of scheduling groups
- * @return Number of scheduling groups supported by this platofmr
+ * @return Number of scheduling groups supported by this platform
  */
 int odp_config_sched_grps(void);
 
diff --git a/include/odp/api/spec/crypto.h b/include/odp/api/spec/crypto.h
index 3e78547..db01684 100644
--- a/include/odp/api/spec/crypto.h
+++ b/include/odp/api/spec/crypto.h
@@ -316,10 +316,10 @@ typedef struct odp_crypto_capability_t {
 	/** Maximum number of crypto sessions */
 	uint32_t max_sessions;
 
-	/** Supported chipher algorithms */
+	/** Supported cipher algorithms */
 	odp_crypto_cipher_algos_t chiphers;
 
-	/** Chipher algorithms implemented with HW offload */
+	/** Cipher algorithms implemented with HW offload */
 	odp_crypto_cipher_algos_t hw_chiphers;
 
 	/** Supported authentication algorithms */
diff --git a/include/odp/api/spec/hints.h b/include/odp/api/spec/hints.h
index 158f802..ff5099c 100644
--- a/include/odp/api/spec/hints.h
+++ b/include/odp/api/spec/hints.h
@@ -26,7 +26,7 @@ extern "C" {
 
 #ifdef __GNUC__
 
-/** Define a fn that does not return
+/** Define a function that does not return
  */
 #define ODP_NORETURN __attribute__((__noreturn__))
 
@@ -57,7 +57,7 @@ extern "C" {
 #define ODP_DEPRECATED __attribute__((__deprecated__))
 
 /**
- * Intentionally unused variables ot functions
+ * Intentionally unused variables of functions
  */
 #define ODP_UNUSED     __attribute__((__unused__))
 
diff --git a/include/odp/api/spec/packet_io.h b/include/odp/api/spec/packet_io.h
index c1c14b2..6fc9644 100644
--- a/include/odp/api/spec/packet_io.h
+++ b/include/odp/api/spec/packet_io.h
@@ -257,7 +257,7 @@ typedef struct odp_pktio_param_t {
  * enabled, implementation will verify checksum correctness on incoming packets
  * and depending on drop configuration either deliver erroneous packets with
  * appropriate flags set (e.g. odp_packet_has_l3_error()) or drop those.
- * When packet droping is enabled, application will never receive a packet
+ * When packet dropping is enabled, application will never receive a packet
  * with the specified error and may avoid to check the error flag.
  */
 typedef union odp_pktin_config_opt_t {
@@ -683,7 +683,7 @@ int odp_pktio_stop(odp_pktio_t pktio);
  * Close a stopped packet IO interface. This call frees all remaining packets
  * stored in pktio receive and transmit side buffers. The pktio is destroyed
  * and the handle must not be used for other calls. After a successful call,
- * the same pktio device can be opened again with a odp_packet_open() call.
+ * the same pktio device can be opened again with a odp_pktio_open() call.
  *
  * @param pktio  Packet IO handle
  *
@@ -755,7 +755,7 @@ int odp_pktin_recv_tmo(odp_pktin_queue_t queue, odp_packet_t packets[],
  * Receives up to 'num' packets from one of the specified pktio interface input
  * queues. The index of the source queue is stored into 'from' output
  * parameter. If there are no packets available on any of the queues, waits for
- * packets depeding on 'wait' parameter value. Returns the number of packets
+ * packets depending on 'wait' parameter value. Returns the number of packets
  * received.
  *
  * When an input queue has been configured with 'op_mode' value
@@ -947,7 +947,7 @@ int odp_pktio_index(odp_pktio_t pktio);
 uint64_t odp_pktio_to_u64(odp_pktio_t pktio);
 
 /**
- * Intiailize pktio params
+ * Initialize pktio params
  *
  * Initialize an odp_pktio_param_t to its default values for all fields
  *
diff --git a/include/odp/api/spec/packet_io_stats.h b/include/odp/api/spec/packet_io_stats.h
index e0a6547..73cf704 100644
--- a/include/odp/api/spec/packet_io_stats.h
+++ b/include/odp/api/spec/packet_io_stats.h
@@ -25,7 +25,7 @@ extern "C" {
 /**
  * Packet IO statistics
  *
- * Packet IO statictics counters follow RFCs for Management Information Base
+ * Packet IO statistics counters follow RFCs for Management Information Base
  * (MIB)for use with network management protocols in the Internet community:
  * https://tools.ietf.org/html/rfc3635
  * https://tools.ietf.org/html/rfc2863
@@ -48,7 +48,7 @@ typedef struct odp_pktio_stats_t {
 
 	/**
 	 * The number of inbound packets which were chosen to be discarded
-	 * even though no errors had been detected to preven their being
+	 * even though no errors had been detected to prevent their being
 	 * deliverable to a higher-layer protocol.  One possible reason for
 	 * discarding such a packet could be to free up buffer space.
 	 * See ifInDiscards in RFC 2863.
diff --git a/include/odp/api/spec/queue.h b/include/odp/api/spec/queue.h
index 7cc031d..f1d0e10 100644
--- a/include/odp/api/spec/queue.h
+++ b/include/odp/api/spec/queue.h
@@ -110,14 +110,14 @@ typedef struct odp_queue_param_t {
 	  *
 	  * Default value for both queue types is ODP_QUEUE_OP_MT. Application
 	  * may enable performance optimizations by defining MT_UNSAFE or
-	  * DISABLED modes when applicaple. */
+	  * DISABLED modes when applicable. */
 	odp_queue_op_mode_t enq_mode;
 
 	/** Dequeue mode
 	  *
 	  * For PLAIN queues, the default value is ODP_QUEUE_OP_MT. Application
 	  * may enable performance optimizations by defining MT_UNSAFE or
-	  * DISABLED modes when applicaple. However, when a plain queue is input
+	  * DISABLED modes when applicable. However, when a plain queue is input
 	  * to the implementation (e.g. a queue for packet output), the
 	  * parameter is ignored in queue creation and the value is
 	  * ODP_QUEUE_OP_DISABLED.
diff --git a/include/odp/api/spec/rwlock.h b/include/odp/api/spec/rwlock.h
index 631df48..2624b56 100644
--- a/include/odp/api/spec/rwlock.h
+++ b/include/odp/api/spec/rwlock.h
@@ -25,7 +25,7 @@ extern "C" {
  *
  * A reader/writer lock allows multiple simultaneous readers but only one
  * writer at a time. A thread that wants write access will have to wait until
- * there are no threads that want read access. This casues a risk for
+ * there are no threads that want read access. This causes a risk for
  * starvation. The trylock variants can be used to avoid blocking when
  * the lock is not immediately available.
  * @{
diff --git a/include/odp/api/spec/schedule.h b/include/odp/api/spec/schedule.h
index a720e03..556d0f1 100644
--- a/include/odp/api/spec/schedule.h
+++ b/include/odp/api/spec/schedule.h
@@ -259,7 +259,7 @@ odp_schedule_group_t odp_schedule_group_lookup(const char *name);
  *
  * Join a threadmask to an existing schedule group
  *
- * @param group  Schdule group handle
+ * @param group  Schedule group handle
  * @param mask   Thread mask
  *
  * @retval 0 on success
diff --git a/include/odp/api/spec/schedule_types.h b/include/odp/api/spec/schedule_types.h
index b394d53..6a4d01c 100644
--- a/include/odp/api/spec/schedule_types.h
+++ b/include/odp/api/spec/schedule_types.h
@@ -45,7 +45,7 @@ extern "C" {
 /**
  * @def ODP_SCHED_PRIO_DEFAULT
  * Default scheduling priority. User does not care about the selected priority
- * level - throughput, load balacing and synchronization features are more
+ * level - throughput, load balancing and synchronization features are more
  * important than priority scheduling.
  */
 
diff --git a/include/odp/api/spec/traffic_mngr.h b/include/odp/api/spec/traffic_mngr.h
index fff4c46..fbd15e4 100644
--- a/include/odp/api/spec/traffic_mngr.h
+++ b/include/odp/api/spec/traffic_mngr.h
@@ -98,13 +98,13 @@ extern "C" {
 
 /**
  * @def ODP_TM_MIN_SHAPER_BW
- * The largest amound of bandwidth that any shaper's peak or commit rate can
+ * The largest amount of bandwidth that any shaper's peak or commit rate can
  * be set to. It is in units of 1000 bytes/second.
  */
 
 /**
  * @def ODP_TM_MAX_SHAPER_BW
- * The largest amound of bandwidth that any shaper's peak or commit rate can
+ * The largest amount of bandwidth that any shaper's peak or commit rate can
  * be set to. It is in units of 1000 bytes/second.
  */
 
@@ -192,7 +192,7 @@ extern "C" {
 
 /** Per Level Capabilities
  *
- * The odp_tm_level_capabilities_t record is used to describe the capabalities
+ * The odp_tm_level_capabilities_t record is used to describe the capabilities
  * that might vary based upon the tm_node level.  It is always used as
  * part of the odp_tm_capabilities record. */
 typedef struct {
@@ -254,7 +254,7 @@ typedef struct {
 typedef struct {
 	/** The name is an optional name associated with a capabilities
 	 * record.  This name, if present, can be used by odp_tm_find to
-	 * return a TM system matching this set of capabilitis. */
+	 * return a TM system matching this set of capabilities. */
 	char *name;
 
 	/** max_tm_queues specifies the maximum number of tm_queues that can
@@ -480,7 +480,7 @@ void odp_tm_egress_init(odp_tm_egress_t *egress);
  * that N is larger than the capabilities_size, N will still be returned,
  * but only capabilities_size records will be filled in.
  *
- * @param[out] capabilities      An arary of odp_tm_capabilities_t records to
+ * @param[out] capabilities      An array of odp_tm_capabilities_t records to
  *                               be filled in.
  * @param[in]  capabilities_size The number of odp_tm_capabilities_t records
  *                               in the capabilities array.
@@ -520,7 +520,7 @@ odp_tm_t odp_tm_create(const char            *name,
  * "HW_TM_%u" where the number starts at 1, can be used to find a built-in
  * system independently of the best requirements match.  If name is NULL then
  * the existing (built-in or created by odp_tm_create) TM system that best
- * matches the requirments is returned.
+ * matches the requirements is returned.
  *
  * @param[in] name          If NULL then only uses the requirements parameter to
  *                          find a closest match, otherwise if the name is
@@ -593,7 +593,7 @@ int odp_tm_destroy(odp_tm_t odp_tm);
 
 /** Vlan Marking.
  *
- * The odp_tm_vlan__marking() function allows one to configure the TM egress
+ * The odp_tm_vlan_marking() function allows one to configure the TM egress
  * so as to have it set the one bit VLAN Drop Eligibility Indicator (DEI)
  * field (but only for pkts that already carry a VLAN tag) of a pkt based upon
  * the final pkt (or shaper?) color assigned to the pkt when it reaches the
@@ -932,7 +932,7 @@ odp_tm_threshold_t odp_tm_threshold_create(const char *name,
 /** Destroy a queue threshold profile object
  *
  * The odp_tm_threshold_destroy() function destroys/frees the given threshold
- * profile object.  It is an error if this thresold profile is still being
+ * profile object.  It is an error if this threshold profile is still being
  * referenced by an active (connected) tm_queue or tm_node.
  *
  * @param[in] threshold_profile  Specifies the queue thresholds profile
@@ -1129,7 +1129,7 @@ typedef struct {
 	 * the odp_tm_node_context() call. */
 	void *user_context;
 
-	/** The max_fan_in sets tha maximum number of src tm_queues and
+	/** The max_fanin sets the maximum number of src tm_queues and
 	 * producer tm_nodes that can be simultaneously be connected to this
 	 * tm_node as their destination. */
 	uint32_t max_fanin;
@@ -1406,7 +1406,7 @@ int odp_tm_queue_shaper_config(odp_tm_queue_t tm_queue,
  * @param[in] tm_node         Specifies the tm_node to be changed.
  * @param[in] tm_fan_in_queue Specifies which of the specified tm_node's
  *                            fan-in's weights etc are to be changed. The
- *                            fan-in is indentified by the "producer"/parent
+ *                            fan-in is identified by the "producer"/parent
  *                            tm_queue actually connected to this fan-in.
  * @param[in] sched_profile   Specifies the scheduler profile that should
  *                            now be used for the WFQ/RR entity within the
@@ -1481,7 +1481,7 @@ int odp_tm_node_connect(odp_tm_node_t src_tm_node, odp_tm_node_t dst_tm_node);
  */
 int odp_tm_node_disconnect(odp_tm_node_t src_tm_node);
 
-/** The odp_queue_connect() function connects the indicated tm_queue to a
+/** The odp_tm_queue_connect() function connects the indicated tm_queue to a
  * parent tm_node or to the egress/root node.  The tm_queue will then become
  * one of the dst node's fan-in set.
  *
@@ -1614,7 +1614,7 @@ typedef struct {
 
 /** Get tm_node Fanin Info
  *
- * The odp_tm_node_fain_info() function is used to extract various bits of
+ * The odp_tm_node_fanin_info() function is used to extract various bits of
  * configuration associated with a given tm_node's fanin.  It can also be
  * used to walk the complete fanin list of a given tm_node.  Note in particular
  * that the odp_tm_node_fanin_info_t record passed to this function is both