diff --git a/include/odp/api/spec/packet.h b/include/odp/api/spec/packet.h
index 4a14f2d..7e347c5 100644
--- a/include/odp/api/spec/packet.h
+++ b/include/odp/api/spec/packet.h
@@ -846,6 +846,149 @@ int odp_packet_split(odp_packet_t *pkt, uint32_t len, odp_packet_t *tail);
 
 /*
  *
+ * References
+ * ********************************************************
+ *
+ */
+
+/**
+ * Create a static reference to a packet
+ *
+ * Create a (shared) reference to a base packet. A static reference is used to
+ * retain a copy of the packet so that the storage behind it is not freed
+ * until all references to the packet are freed. This can be used, for
+ * example, to support efficient retransmission processing.
+ *
+ * @param pkt    Handle of the base packet for which a static reference is
+ *               to be created.
+ *
+ * @return                    Handle of the reference packet
+ * @retval ODP_PACKET_INVALID Operation failed. Base packet remains unchanged.
+ *
+ * @note The intent of a static reference is that both the base packet and the
+ *       returned reference should be treated as read-only after this
+ *       call. Results are unpredictable if this restriction is not observed.
+ *
+ * @note Static references have restrictions but may have performance
+ *       advantages on some platforms if the caller does not intend to modify
+ *       the reference packet. If modification is needed (e.g., to prefix a
+ *       unique header onto the packet) then odp_packet_ref() should be used.
+ */
+odp_packet_t odp_packet_ref_static(odp_packet_t pkt);
+
+/**
+ * Create a reference to a packet
+ *
+ * Create a (shared) reference to a base packet starting at a specified byte
+ * offset. This reference may be used as an argument to header manipulation
+ * APIs to prefix a unique header onto the shared base. The storage associated
+ * with the base packet is not freed until all references to it are freed,
+ * which permits easy multicasting or retransmission processing to be
+ * performed.
+ *
+ * @param pkt    Handle of the base packet for which a reference is to be
+ *               created.
+ *
+ * @param offset Byte offset in the base packet at which the shared reference
+ *               is to begin. Must be in the range 0..odp_packet_len(pkt)-1.
+ *
+ * @return                    Handle of the reference packet
+ * @retval ODP_PACKET_INVALID Operation failed. Base packet remains unchanged.
+ *
+ * @note This operation prepends a zero-length header onto the base packet
+ *       beginning at the specified offset. This header is always drawn from
+ *       the same pool as the base packet.
+ *
+ * @note Because references are unique packets, any bytes pushed onto the head
+ *       of a reference via odp_packet_push_head() or odp_packet_extend_head()
+ *       are unique to this reference and are not seen by any other reference
+ *       to the same base packet.
+ *
+ * @note The base pkt used as input to this routine may itself by a reference
+ *       to some other base packet. Implementations MAY restrict the ability
+ *       to create such compound references. Attempts to exceed any
+ *       implementation limits in this regard will result in this call failing
+ *       and returning ODP_PACKET_INVALID.
+ *
+ * @note If the caller does not indend to push a header onto the returned
+ *       reference, the odp_packet_ref_static() API may be used. This may be a
+ *       more efficient means of obtaining another reference to a base packet
+ *       that will be treated as read-only.
+ */
+odp_packet_t odp_packet_ref(odp_packet_t pkt, uint32_t offset);
+
+/**
+ * Create a reference to another packet from a header packet
+ *
+ * Create a (shared) reference to a base packet starting at a specified byte
+ * offset by prepending a header packet. The resulting reference consists of
+ * the unshared header followed by the shared base packet starting at the
+ * specified offset. This shared portion should be regarded as read-only. The
+ * storage associated with the shared portion of the reference is not freed
+ * until all references to it are freed, which permits easy multicasting or
+ * retransmission processing to be performed.
+ *
+ * @param pkt    Handle of the base packet for which a reference is to be
+ *               created.
+ *
+ * @param offset Byte offset in the base packet at which the shared reference
+ *               to begin. Must be in the range 0..odp_packet_len(pkt)-1.
+ *
+ * @param hdr    Handle of the header packet to be prefixed onto the base
+ *               packet to create the reference. If this is specified as
+ *               ODP_PACKET_INVALID, this call is equivalent to
+ *               odp_packet_ref().
+ *
+ * @return       Handle of the reference packet. This may or may not be the
+ *               same as the input hdr packet. The caller should only use this
+ *               handle since the original hdr packet no longer has any
+ *               independent existence.
+ *
+ * @retval ODP_PACKET_INVALID If the reference failed. In this case both pkt
+ *                            and hdr are unchanged.
+ *
+ * @note Either packet input to this routine may itself be a reference,
+ *       however individual implementations MAY impose limits on how deeply
+ *       splices may be nested and fail the call if those limits are exceeded.
+ *
+ * @note The packets used as input to this routine may reside in different
+ *       pools, however individual implementations MAY require that both
+ *       reside in the same pool and fail the call if this restriction is not
+ *       observed. odp_packet_pool() on the returned reference returns the
+ *       pool id of the header packet.
+ */
+odp_packet_t odp_packet_ref_pkt(odp_packet_t pkt, uint32_t offset,
+				odp_packet_t hdr);
+
+/**
+ * Test if a packet is a reference
+ *
+ * A packet is a reference if it was created by odp_packet_ref_xxx().
+ * Note that a reference created from another reference is considered
+ * a compound reference.
+ *
+ * @param pkt Packet handle
+ *
+ * @retval 0  Packet is not a reference
+ * @retval >0 Packet is a reference consisting of N individual packets.
+ */
+int odp_packet_is_a_ref(odp_packet_t pkt);
+
+/**
+ * Test if a packet is referenced
+ *
+ * A packet is referenced if a reference was created on it by
+ * odp_packet_ref_xxx().
+ *
+ * @param pkt Packet handle
+ *
+ * @retval 0  Packet is not referenced
+ * @retval >0 Packet is N references based on it
+ */
+int odp_packet_is_referenced(odp_packet_t pkt);
+
+/*
+ *
  * Copy
  * ********************************************************
  *